#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hashsearch.h"

// ؽ ̺ .
HashTable* createHashTable(int bucketSize) {
	HashTable *pReturn = NULL;

	if (bucketSize <= 0) {
		printf("Ŷ ũ 0 Ŀմϴ\n");
		return NULL;
	}

	pReturn = (HashTable *)malloc(sizeof(HashTable));
	if (pReturn != NULL) {
		pReturn->currentCount = 0;
		pReturn->bucketSize = bucketSize;
		pReturn->pBucket = NULL;
	}
	else {
		printf(", ù° ޸Ҵ, createHashTable()\n");
		return NULL;
	}

	pReturn->pBucket = (HashBucket *)malloc(sizeof(HashBucket) * bucketSize);
	if (pReturn->pBucket != NULL) {
		memset(pReturn->pBucket, 0, sizeof(HashBucket) * bucketSize);
	}
	else {
		if (pReturn != NULL) free(pReturn);
		printf(", ι° ޸Ҵ, createHashTable()\n");
		return NULL;
	}
	return pReturn;	
}

// ڷ ߰.
int addData(HashTable* pHashTable, HashBucket bucket) {
	int ret = 0;
	HashBucket *pBucket = NULL;
	int bucketIndex = 0;
	int tempIndex = 0;
	int inc = 1;

	if (pHashTable == NULL) {
		printf(",NULL-ؽ ̺Դϴ\n");
		ret = 0;
		return ret;
	}

	bucketIndex = hashFunction(bucket.key, pHashTable->bucketSize);
	if (bucketIndex < 0 || bucketIndex >= pHashTable->bucketSize) {
		printf(", ߸ ؽ ̺ ּҰ Ǿϴ, addSHT()\n");
		ret = 0;
		return ret;
	}

	tempIndex = bucketIndex;

	do {
		pBucket = &(pHashTable->pBucket[tempIndex]);

		// 1)  ּ Ȥ  ּ .
		if (isEmptyOrDeletedBucket(pBucket) == 1) {
			pHashTable->pBucket[tempIndex] = bucket;
			pHashTable->pBucket[tempIndex].status = USED;
			pHashTable->currentCount++;
			ret = 1;
			break;
		}
		else {	// 2)   ã  .
			// 2-1)  key ̹ ϴ .
			if (strcmp(pBucket->key, bucket.key) == 0) {
				printf(", ߺ Ű-[%s], addSHT()\n",
						bucket.key);
				ret = 0;
				break;
			}
			else { // 2-2)  ʴ key ,   ̵.
				tempIndex = (tempIndex + inc) % pHashTable->bucketSize;

				// ؽ ̺     .
				if (tempIndex == bucketIndex) {
					printf(", ؽ ̺ áϴ\n");
					ret = 0;
					break;
				}
			}					
		}
	}
	while(tempIndex != bucketIndex);

	return ret;
}

int hashFunction(char *pKey, int bucketSize) {
	int ret = -1;
	unsigned int temp_key = 0;

	if (pKey == NULL) {
		return ret;
	}

	temp_key = stringToInt(pKey);
	if (bucketSize > 0) {
		ret = temp_key % bucketSize;
	}

	return ret;
}

// ڿ ڷ ȯ.
unsigned int stringToInt(char *pKey) {
	unsigned int ret = 0;
	while(*pKey != '\0') {
		ret = (ret * 31) + (*pKey);
		pKey++;
	}

	return ret;
}

//  ּ Ȥ  ּ .
int isEmptyOrDeletedBucket(HashBucket* pBucket) {
	int ret = 0;

	if (pBucket != NULL) {
		if (pBucket->status == EMPTY
			|| pBucket->status == DELETED) {
			ret = 1;
		}
	}

	return ret;
}

// ڷ ˻.
HashBucket* search(HashTable* pHashTable, char* key) {
	HashBucket* pReturn = NULL;
	HashBucket *pBucket = NULL;
	int bucketIndex = 0;
	int tempIndex = 0;

	if (pHashTable == NULL) {
		printf(",NULL-ؽ ̺Դϴ\n");
		pReturn = NULL;
		return pReturn;
	}

	bucketIndex = hashFunction(key, pHashTable->bucketSize);
	if (bucketIndex < 0) {
		printf(", ߸ ؽ ̺ ּҰ Ǿϴ\n");
		pReturn = NULL;
		return pReturn;
	}

	tempIndex = bucketIndex;

	do {
		pBucket = &(pHashTable->pBucket[tempIndex]);

		// 1)   ã . ˻ .
		if (isEmptyBucket(pBucket) == 1) {
			printf("˻ , ˻Ű-[%s]  ʽϴ\n", key);
			pReturn = NULL;
			break;
		}
		else {
			// 2-1)  key ã . ˻ .
			if (pBucket->status == USED 
					&& strcmp(pBucket->key, key) == 0) {
				pReturn = pBucket;
				break;
			}
			else { // 2-2)  ʴ key ,  ּҷ ̵.
				tempIndex = (tempIndex + 1) % pHashTable->bucketSize;
				
				// ؽ ̺   ˻ .
				if (tempIndex == bucketIndex) {
					printf("˻ , ˻Ű-[%s]  ʽϴ\n", key);
					pReturn = NULL;
					break;
				}
			}					
		}
	}
	while(tempIndex != bucketIndex);

	return pReturn;
}

//  ּ .
int isEmptyBucket(HashBucket* pBucket) {
	int ret = 0;

	if (pBucket != NULL) {
		if (pBucket->status == EMPTY) {
			ret = 1;
		}
	}

	return ret;
}

// ڷ .
int removeData(HashTable* pHashTable, char* key) {
	int ret = 0;
	HashBucket *pBucket = NULL;

	if (pHashTable != NULL) {
		pBucket = search(pHashTable, key);
		if (pBucket != NULL) {
			pBucket->status = DELETED;
			pBucket->key[0] = '\0';
			pBucket->value = 0;
			pHashTable->currentCount--;
			ret = 1;
		}
		else {
			printf(" , ˻Ű-[%s]  ʽϴ\n", key);
		}
	}

	return ret;
}

// ؽ ̺ .
void deleteHashTable(HashTable *pHashTable) {
	if (pHashTable != NULL) {
		free(pHashTable->pBucket);
	}
	free(pHashTable);
}

// ؽ ̺  ڷ .
int getCount(HashTable *pHashTable) {
	int ret = 0;

	if (pHashTable != NULL) {
		ret = pHashTable->currentCount;
	}

	return ret;
}

// ؽ ̺  .
void displayHashTable(HashTable *pHashTable) {
	int i = 0;
	int bucketIndex = 0;

	HashBucket *pBucket = NULL;
	if (pHashTable != NULL) {
		printf("-----------------------------------------\n");

		for(i = 0; i < pHashTable->bucketSize; i++) {
			printf("[%d],", i);

			pBucket = &(pHashTable->pBucket[i]);
			if (pBucket->key[0] != '\0') {
				bucketIndex = hashFunction(pBucket->key, pHashTable->bucketSize);

				printf("%s, (%d->%d), [%d]\n", pBucket->key, 
					bucketIndex, i,
					pBucket->value);
			}
			else {
				printf("ϴ\n");
			}
		}

		printf("-----------------------------------------\n");
	}
	else {
		printf("NULL-ؽ ̺Դϴ\n");
	}
}
